namespace org.accordproject.trademark;
using org.accordproject.address;
using org.accordproject.geo;
using org.accordproject.person;
using org.accordproject.usa.entity;
using org.accordproject.color;
using AccordProject.Concerto;
[AccordProject.Concerto.Type(Namespace = "org.accordproject.trademark", Version = "0.2.0", Name = "TrademarkAssetIdentifier")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class TrademarkAssetIdentifier : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.trademark@0.2.0.TrademarkAssetIdentifier";
   public string assetSerialNumber { get; set; }
   public string assetRegistrationNumber { get; set; }
   public Country assetCountry { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.trademark", Version = "0.2.0", Name = "GoodsAndServices")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class GoodsAndServices : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.trademark@0.2.0.GoodsAndServices";
   public string gsDescription { get; set; }
   public string intlClass { get; set; }
   public string usClass { get; set; }
   public string currentFilingBasis { get; set; }
   public string origFilingBasis { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.trademark", Version = "0.2.0", Name = "Owner")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Owner : Person {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.trademark@0.2.0.Owner";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.trademark", Version = "0.2.0", Name = "Registrant")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Registrant : Person {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.trademark@0.2.0.Registrant";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.trademark", Version = "0.2.0", Name = "Assignee")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Assignee : Person {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.trademark@0.2.0.Assignee";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.trademark", Version = "0.2.0", Name = "Correspondent")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Correspondent : Person {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.trademark@0.2.0.Correspondent";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.trademark", Version = "0.2.0", Name = "Attorney")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Attorney : Person {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.trademark@0.2.0.Attorney";
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum MarkStatus {
      Live,
      Dead,
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum MarkType {
      Standard_Character,
      Special_Form,
      Sound,
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum Register {
      Principal,
      Supplemental,
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.trademark", Version = "0.2.0", Name = "TrademarkAsset")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class TrademarkAsset : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.trademark@0.2.0.TrademarkAsset";
   public TrademarkAssetIdentifier assetIdentifier { get; set; }
   public string encodedMarkImage { get; set; }
   public string markDescription { get; set; }
   public GoodsAndServices?[] goodsandServices { get; set; }
   public Owner? originalOwner { get; set; }
   public EntityType? entityType { get; set; }
   public Registrant? originalRegistrant { get; set; }
   public Assignee? currentAssignee { get; set; }
   public Correspondent? currentCorrespondent { get; set; }
   public Attorney? attorneyRepresentative { get; set; }
   public MarkStatus? markStatus { get; set; }
   public MarkType? markType { get; set; }
   public Register? register { get; set; }
   public string literalElement { get; set; }
   public bool? colorClaim { get; set; }
   public Color?[] colorFeature { get; set; }
   public System.DateTime? filingDate { get; set; }
   public System.DateTime? registrationDate { get; set; }
}
